<?php

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
ini_set('max_execution_time', 7200); //300 seconds = 5 minutes

// =============================================================================================

function is_cli() {
	if( defined('STDIN') ) 	{
		return true;
	}
	
	if( empty($_SERVER['REMOTE_ADDR']) and !isset($_SERVER['HTTP_USER_AGENT']) and count($_SERVER['argv']) > 0) {
		return true;
	} 
	
	return false;
}

function getTitleFromLog ($searchfor)
{
    // escape special characters in the query
    $pattern = preg_quote($searchfor, '/');
    // finalise the regular expression, matching the whole line
    $pattern = "/^.*$pattern.*\$/m";
    // search, and store all matching occurences in $matches
    global $contents;
    if(preg_match_all($pattern, $contents, $matches)){
    // echo "Found matches:\n";
    // echo implode("\n", $matches[0]);
    $results = explode('=:=',implode("\n",$matches[0] ));
    return array($results[1],$results[2],$results[4]);
    }
    else{
    // echo "No matches found";
    return "NO TITLE FOUND";
    }
}

// =============================================================================================

// OP7P - 1400 x 3120 pixels, 516 ppi, 19.5:9 aspect ratio.
// LG GPAD 5 - 1200 x 1920 pixels, 16:10 ratio (~224 ppi density)
// Alcatel A30 - 1200 x 800 pixels, 180 PPI
// Samsung Galaxy S8+ - 1440 x 2960 pixels, 18.5:9 ratio (~529 ppi density)

if ( php_uname('s') == "Linux") {
    // for linux
    $a = '/var/www/sites/api/webhooks/assets';
    $t = '/var/www/sites/api/webhooks/test/assets';
  } else {
    // for windows
    $a = 'C:/xampp/htdocs/sites/api/webhooks/assets';
    $t = 'C:/xampp/htdocs/sites/api/webhooks/test/assets';
  }
  
  define('ASSETS',$a);
  define('TESTFOLDER',$t);
  $totalWalls = 0;
  
  if (is_cli()) {
    $docroot = '/var/www/sites/api/';  
    $eol = "\n";
  } else {
    $docroot = $_SERVER['DOCUMENT_ROOT'] . '/';
    $eol = "<br />\n";
  }

$currlog = $docroot . 'webhooks/' . date('Ymd') . '-reddit_walls.txt';
$oldlogs = $docroot . 'webhooks/logs/';
$assets  = $docroot . 'webhooks/assets/';
$wallCategory = array('amoledbackgrounds','mobilewallpaper','wallpaper','wqhd_wallpaper','cityporn','earthporn','skyporn','spaceporn','waterporn','weatherporn');
$catPathColor = array(
    'amoledbackgrounds'=>array('wallpath'=>'/assets/amoledbackgrounds','colorkey'=>'#9C27B0'),  // purple 500
    'wallpaper'=>array('wallpath'=>'/assets/wallpaper','colorkey'=>'#FF5722'),                  // deep orange 500
    'wallpapers'=>array('wallpath'=>'/assets/wallpaper','colorkey'=>'#FF5722'),                 // deep orange 500
    'mobilewallpaper'=>array('wallpath'=>'/assets/mobilewallpaper','colorkey'=>'#CDDC39'),      // lime 500
    'mobilewallpapers'=>array('wallpath'=>'/assets/mobilewallpaper','colorkey'=>'#CDDC39'),     // lime 500
    'cityporn'=>array('wallpath'=>'/assets/cityporn','colorkey'=>'#2196F3'),                    // blue 500
    'earthporn'=>array('wallpath'=>'/assets/earthporn','colorkey'=>'#4CAF50'),                  // green 500
    'skyporn'=>array('wallpath'=>'/assets/skyporn','colorkey'=>'#F44336'),                      // red 500
    'spaceporn'=>array('wallpath'=>'/assets/spaceporn','colorkey'=>'#FFC107'),                  // amber 500
    'waterporn'=>array('wallpath'=>'/assets/waterporn','colorkey'=>'#009688'),                  // teal 500
    'weatherporn'=>array('wallpath'=>'/assets/weatherporn','colorkey'=>'#3F51B5'),              // indigo 500
    'tapet'=>array('wallpath'=>'/assets/tapet','colorkey'=>'#FFEB3B'),                          // yellow 500
    'wqhd_wallpaper'=>array('wallpath'=>'/assets/wqhd_wallpaper','colorkey'=>'#673AB7')         // deep purple 500
    );

include ('includes/curl_error_results.php');
        // echo "<pre>"; print_r($error_codes); echo "</pre>";

        // GET THE CONTENTS OF ALL THE LOGS TO SEARCH THROUGH
        $scanOldLogs = array_values(array_diff(scandir($oldlogs), array('..', '.')));
        sort($scanOldLogs,SORT_NATURAL);
        
        $numOfOldLogs = count($scanOldLogs);
        
        foreach ($scanOldLogs as $key=>$logfile)
        {
            if (!isset($contents))
            {
                $contents = file_get_contents($oldlogs . $logfile);    
            }
            else
            {
                $contents .= file_get_contents($oldlogs . $logfile);
            }             
        }
        
        $contents .= file_get_contents($currlog);

foreach ($wallCategory as $wallCatKey=>$wallsubcat)
{

    // if ($wallsubcat == 'wallpaper')

    // {

    
        $scannedAssets = array_values(array_diff(scandir($assets . $wallsubcat), array('..', '.')));
        $countScannedAssets = count($scannedAssets);

        // $wallTitle = getTitleFromLog($imgfile);

        echo "$wallsubcat - $countScannedAssets files$eol";

        foreach ($scannedAssets as $assetKey=>$imgfile)
        {
            $fs = filesize($assets. $wallsubcat . '/' .$imgfile);
            if ($fs == 0)
            {
                list($wallTitle,$rawURL,$filename) = getTitleFromLog($imgfile);
                echo "path = $assets$eol";
                echo "Sub cateory = $wallsubcat$eol";
                echo "Filename = $imgfile$eol";
                echo "Filesize = $fs$eol";
                echo "Title = $wallTitle$eol";
                echo "Reddit URL = $rawURL$eol";
                echo "$eol";

                // unlink()

                $ch = curl_init($rawURL);
                $fp = fopen($assets . $wallsubcat . '/' . $imgfile, 'wb');
                curl_setopt($ch, CURLOPT_FILE, $fp);
                curl_setopt($ch, CURLOPT_HEADER, 0);
                curl_exec($ch);
            
                $errNo = curl_errno($ch);

                if (!curl_errno($ch)) 
                {
                    switch ($http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE)) {
                        case 200:  # OK
                            echo "It was good : $http_code$eol";
                            curl_close($ch);
                            fclose($fp);
                            break;
                        default:
                            echo  "cURL error: " . $errNo . " => " . $error_codes[$errNo] . "\n";
                            echo 'Unexpected HTTP code: ', $http_code, "$eol";
                            unlink($outputWall);
                    }
                }

            }
        }
    // }
}



?>