<?php
$rustart = getrusage();

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
ini_set('max_execution_time', 7200); //300 seconds = 5 minutes

include_once('html-top.php');

include ('./includes/flush_n_sleep.inc.php');

function rutime($ru, $rus, $index) 
{
    return ($ru["ru_$index.tv_sec"]*1000 + intval($ru["ru_$index.tv_usec"]/1000))
     -  ($rus["ru_$index.tv_sec"]*1000 + intval($rus["ru_$index.tv_usec"]/1000));
}

function getTitleFromLog ($searchfor)
{
    // escape special characters in the query
    $pattern = preg_quote($searchfor, '/');
    // finalise the regular expression, matching the whole line
    $pattern = "/^.*$pattern.*\$/m";
    // search, and store all matching occurences in $matches
    global $contents;
    if(preg_match_all($pattern, $contents, $matches)){
    // echo "Found matches:\n";
    // echo implode("\n", $matches[0]);
    $results = explode('=:=',implode("\n",$matches[0] ));
    return array($results[1],$results[2],$results[4]);
    }
    else{
    // echo "No matches found";
    return "NO TITLE FOUND";
    }
}

// OP7P - 1400 x 3120 pixels, 516 ppi, 19.5:9 aspect ratio.
// LG GPAD 5 - 1200 x 1920 pixels, 16:10 ratio (~224 ppi density)
// Alcatel A30 - 1200 x 800 pixels, 180 PPI
// Samsung Galaxy S8+ - 1440 x 2960 pixels, 18.5:9 ratio (~529 ppi density)


$docroot = $_SERVER['DOCUMENT_ROOT'] . '/';
$currlog = $docroot . 'webhooks/' . date('Ymd') . '-reddit_walls.txt';
$oldlogs = $docroot . 'webhooks/logs/';
$assets  = $docroot . 'webhooks/assets/';
$wallCategory = array('amoledbackgrounds','mobilewallpaper','wallpaper','wqhd_wallpaper','cityporn','earthporn','skyporn','spaceporn','waterporn','weatherporn');
$catPathColor = array(
    'amoledbackgrounds'=>array('wallpath'=>'/assets/amoledbackgrounds','colorkey'=>'#9C27B0'),  // purple 500
    'wallpaper'=>array('wallpath'=>'/assets/wallpaper','colorkey'=>'#FF5722'),                  // deep orange 500
    'wallpapers'=>array('wallpath'=>'/assets/wallpaper','colorkey'=>'#FF5722'),                 // deep orange 500
    'mobilewallpaper'=>array('wallpath'=>'/assets/mobilewallpaper','colorkey'=>'#CDDC39'),      // lime 500
    'mobilewallpapers'=>array('wallpath'=>'/assets/mobilewallpaper','colorkey'=>'#CDDC39'),     // lime 500
    'cityporn'=>array('wallpath'=>'/assets/cityporn','colorkey'=>'#2196F3'),                    // blue 500
    'earthporn'=>array('wallpath'=>'/assets/earthporn','colorkey'=>'#4CAF50'),                  // green 500
    'skyporn'=>array('wallpath'=>'/assets/skyporn','colorkey'=>'#F44336'),                      // red 500
    'spaceporn'=>array('wallpath'=>'/assets/spaceporn','colorkey'=>'#FFC107'),                  // amber 500
    'waterporn'=>array('wallpath'=>'/assets/waterporn','colorkey'=>'#009688'),                  // teal 500
    'weatherporn'=>array('wallpath'=>'/assets/weatherporn','colorkey'=>'#3F51B5'),              // indigo 500
    'tapet'=>array('wallpath'=>'/assets/tapet','colorkey'=>'#FFEB3B'),                          // yellow 500
    'wqhd_wallpaper'=>array('wallpath'=>'/assets/wqhd_wallpaper','colorkey'=>'#673AB7')         // deep purple 500
    );

    $error_codes=array
    (
    1 => 'CURLE_UNSUPPORTED_PROTOCOL',
    2 => 'CURLE_FAILED_INIT',
    3 => 'CURLE_URL_MALFORMAT',
    4 => 'CURLE_URL_MALFORMAT_USER',
    5 => 'CURLE_COULDNT_RESOLVE_PROXY',
    6 => 'CURLE_COULDNT_RESOLVE_HOST',
    7 => 'CURLE_COULDNT_CONNECT',
    8 => 'CURLE_FTP_WEIRD_SERVER_REPLY',
    9 => 'CURLE_REMOTE_ACCESS_DENIED',
    11 => 'CURLE_FTP_WEIRD_PASS_REPLY',
    13 => 'CURLE_FTP_WEIRD_PASV_REPLY',
    14=>'CURLE_FTP_WEIRD_227_FORMAT',
    15 => 'CURLE_FTP_CANT_GET_HOST',
    17 => 'CURLE_FTP_COULDNT_SET_TYPE',
    18 => 'CURLE_PARTIAL_FILE',
    19 => 'CURLE_FTP_COULDNT_RETR_FILE',
    21 => 'CURLE_QUOTE_ERROR',
    22 => 'CURLE_HTTP_RETURNED_ERROR',
    23 => 'CURLE_WRITE_ERROR',
    25 => 'CURLE_UPLOAD_FAILED',
    26 => 'CURLE_READ_ERROR',
    27 => 'CURLE_OUT_OF_MEMORY',
    28 => 'CURLE_OPERATION_TIMEDOUT',
    30 => 'CURLE_FTP_PORT_FAILED',
    31 => 'CURLE_FTP_COULDNT_USE_REST',
    33 => 'CURLE_RANGE_ERROR',
    34 => 'CURLE_HTTP_POST_ERROR',
    35 => 'CURLE_SSL_CONNECT_ERROR',
    36 => 'CURLE_BAD_DOWNLOAD_RESUME',
    37 => 'CURLE_FILE_COULDNT_READ_FILE',
    38 => 'CURLE_LDAP_CANNOT_BIND',
    39 => 'CURLE_LDAP_SEARCH_FAILED',
    41 => 'CURLE_FUNCTION_NOT_FOUND',
    42 => 'CURLE_ABORTED_BY_CALLBACK',
    43 => 'CURLE_BAD_FUNCTION_ARGUMENT',
    45 => 'CURLE_INTERFACE_FAILED',
    47 => 'CURLE_TOO_MANY_REDIRECTS',
    48 => 'CURLE_UNKNOWN_TELNET_OPTION',
    49 => 'CURLE_TELNET_OPTION_SYNTAX',
    51 => 'CURLE_PEER_FAILED_VERIFICATION',
    52 => 'CURLE_GOT_NOTHING',
    53 => 'CURLE_SSL_ENGINE_NOTFOUND',
    54 => 'CURLE_SSL_ENGINE_SETFAILED',
    55 => 'CURLE_SEND_ERROR',
    56 => 'CURLE_RECV_ERROR',
    58 => 'CURLE_SSL_CERTPROBLEM',
    59 => 'CURLE_SSL_CIPHER',
    60 => 'CURLE_SSL_CACERT',
    61 => 'CURLE_BAD_CONTENT_ENCODING',
    62 => 'CURLE_LDAP_INVALID_URL',
    63 => 'CURLE_FILESIZE_EXCEEDED',
    64 => 'CURLE_USE_SSL_FAILED',
    65 => 'CURLE_SEND_FAIL_REWIND',
    66 => 'CURLE_SSL_ENGINE_INITFAILED',
    67 => 'CURLE_LOGIN_DENIED',
    68 => 'CURLE_TFTP_NOTFOUND',
    69 => 'CURLE_TFTP_PERM',
    70 => 'CURLE_REMOTE_DISK_FULL',
    71 => 'CURLE_TFTP_ILLEGAL',
    72 => 'CURLE_TFTP_UNKNOWNID',
    73 => 'CURLE_REMOTE_FILE_EXISTS',
    74 => 'CURLE_TFTP_NOSUCHUSER',
    75 => 'CURLE_CONV_FAILED',
    76 => 'CURLE_CONV_REQD',
    77 => 'CURLE_SSL_CACERT_BADFILE',
    78 => 'CURLE_REMOTE_FILE_NOT_FOUND',
    79 => 'CURLE_SSH',
    80 => 'CURLE_SSL_SHUTDOWN_FAILED',
    81 => 'CURLE_AGAIN',
    82 => 'CURLE_SSL_CRL_BADFILE',
    83 => 'CURLE_SSL_ISSUER_ERROR',
    84 => 'CURLE_FTP_PRET_FAILED',
    84 => 'CURLE_FTP_PRET_FAILED',
    85 => 'CURLE_RTSP_CSEQ_ERROR',
    86 => 'CURLE_RTSP_SESSION_ERROR',
    87 => 'CURLE_FTP_BAD_FILE_LIST',
    88 => 'CURLE_CHUNK_FAILED'
    );

        // echo "<pre>"; print_r($error_codes); echo "</pre>";

        // GET THE CONTENTS OF ALL THE LOGS TO SEARCH THROUGH
        $scanOldLogs = array_values(array_diff(scandir($oldlogs), array('..', '.')));
        sort($scanOldLogs,SORT_NATURAL);
        
        $numOfOldLogs = count($scanOldLogs);
        
        foreach ($scanOldLogs as $key=>$logfile)
        {
            if (!isset($contents))
            {
                $contents = file_get_contents($oldlogs . $logfile);    
            }
            else
            {
                $contents .= file_get_contents($oldlogs . $logfile);
            }             
        }
        
        $contents .= file_get_contents($currlog);

foreach ($wallCategory as $wallCatKey=>$wallsubcat)
{

    // if ($wallsubcat == 'wallpaper')

    // {

    
        $scannedAssets = array_values(array_diff(scandir($assets . $wallsubcat), array('..', '.')));
        $countScannedAssets = count($scannedAssets);

        // $wallTitle = getTitleFromLog($imgfile);

        echo "$wallsubcat - $countScannedAssets files<br/>\n";

        foreach ($scannedAssets as $assetKey=>$imgfile)
        {
            $fs = filesize($assets. $wallsubcat . '/' .$imgfile);
            if ($fs == 0)
            {
                list($wallTitle,$rawURL,$filename) = getTitleFromLog($imgfile);
                echo "path = $assets<br/>\n";
                echo "Sub cateory = $wallsubcat<br/>\n";
                echo "Filename = $imgfile<br/>\n";
                echo "Filesize = $fs<br/>\n";
                echo "Title = $wallTitle<br/>\n";
                echo "Reddit URL = $rawURL<br/>\n";
                echo "<br/>\n";

                // unlink()

                $ch = curl_init($rawURL);
                $fp = fopen($assets . $wallsubcat . '/' . $imgfile, 'wb');
                curl_setopt($ch, CURLOPT_FILE, $fp);
                curl_setopt($ch, CURLOPT_HEADER, 0);
                curl_exec($ch);
            
                $errNo = curl_errno($ch);

                if (!curl_errno($ch)) 
                {
                    switch ($http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE)) {
                        case 200:  # OK
                            echo "It was good : $http_code<br/>\n";
                            curl_close($ch);
                            fclose($fp);
                            break;
                        default:
                            echo  "cURL error: " . $errNo . " => " . $error_codes[$errNo] . "<br/>";
                            echo 'Unexpected HTTP code: ', $http_code, "\n";
                            unlink($outputWall);
                    }
                }
                flush_n_sleep(0);
                sleep(15);
            }
        }
    // }
}

$ru = getrusage();
echo "This process used " . rutime($ru, $rustart, "utime") .
    " ms for its computations\n";
echo "It spent " . rutime($ru, $rustart, "stime") .
    " ms in system calls\n";

include_once('html-btm.php');

?>