<?php

function print_var_name($var)
{
    foreach ($GLOBALS as $var_name => $value) {
        if ($value === $var) {
            return $var_name;
        }
    }
    return false;
}

function showArray($arr)
{
    $desc = print_var_name($arr);
    echo "~";
    echo str_repeat("^~", 75);
    echo "\n<br/>\n";
    echo $desc . " (" . count($arr) . ") - BEGIN<br/>";
    echo "~";
    echo str_repeat("^~", 75);
    echo "\n<br/>\n";
    echo "<pre class='style'>";
    print_r($arr);
    echo "</pre>";
    echo "~";
    echo str_repeat("^~", 75);
    echo "\n<br/>\n";
    echo "$desc - END<br/>";
    echo "~";
    echo str_repeat("^~", 75);
    echo "\n<br/>\n";
}

function allVars()
{
    $varArr = get_defined_vars();
    echo "<pre>";
    print_r($varArr);
    echo "</pre>";
}

function check($number)
{
    if ($number % 2 == 0) {
        $result = "even";
    } else {
        $result = "odd";
    }
}

function packageArray($array)
{
    $array = serialize($array);
    $array = rawurlencode($array);
    return $array;
}

function unpackageArray($array, $idx)
{
    $array = $_POST[$idx];
    $array = rawurldecode($array);
    $array = unserialize($array);
    return $array;
}

function ordinalize($num)
{
    $suff = 'th';
    if (! in_array(($num % 100), array(11,12,13))) {
        switch ($num % 10) {
                case 1:  $suff = 'st'; break;
                case 2:  $suff = 'nd'; break;
                case 3:  $suff = 'rd'; break;
            }
        return "{$num}{$suff}";
    }
    return "{$num}{$suff}";
}

// ================================== RANDOM HEX COLOR =========================

function random_color_part()
{
    return str_pad(dechex(mt_rand(0, 255)), 2, '0', STR_PAD_LEFT);
}

function random_color()
{
    return random_color_part() . random_color_part() . random_color_part();
}

// echo random_color();  <== Use this in script to call for random color
// ================================== RANDOM HEX COLOR =========================

function human_filesize($bytes, $decimals = 2) {
    $factor = floor((strlen($bytes) - 1) / 3);
    if ($factor > 0) $sz = 'KMGT';
    return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$sz[$factor - 1] . 'B';
}

function print_r_tree($data)
{
    // capture the output of print_r
    $out = print_r($data, true);

    // replace something like '[element] => <newline> (' with <a href="javascript:toggleDisplay('...');">...</a><div id="..." style="display: none;">
    $out = preg_replace('/([ \t]*)(\[[^\]]+\][ \t]*\=\>[ \t]*[a-z0-9 \t_]+)\n[ \t]*\(/iU',"'\\1<a href=\"javascript:toggleDisplay(\''.(\$id = substr(md5(rand().'\\0'), 0, 7)).'\');\">\\2</a><div id=\"'.\$id.'\" style=\"display: none;\">'", $out);

    // replace ')' on its own on a new line (surrounded by whitespace is ok) with '</div>
    $out = preg_replace('/^\s*\)\s*$/m', '</div>', $out);

    // print the javascript function toggleDisplay() and then the transformed output
    echo '<script language="Javascript">function toggleDisplay(id) { document.getElementById(id).style.display = (document.getElementById(id).style.display == "block") ? "none" : "block"; }</script>'."\n$out";
}

function imageType ($img) {
    $imgType = exif_imagetype($img);
        
    switch ($imgType) {
        case 1  :   $type = "IMAGETYPE_GIF"; break;
        case 2  :   $type = "IMAGETYPE_JPEG"; break;
        case 3  : 	$type = "IMAGETYPE_PNG"; break;
        case 4  : 	$type = "IMAGETYPE_SWF"; break;
        case 5  : 	$type = "ITYPE_PSD"; break;
        case 6  : 	$type = "IMAGETYPE_BMP"; break;
        case 7  : 	$type = "IMAGETYPE_TIFF_II (intel byte order)"; break;
        case 8  : 	$type = "IMAGETYPE_TIFF_MM (motorola byte order)"; break;
        case 9  : 	$type = "IMAGETYPE_JPC"; break;
        case 10 : 	$type = "IMAGETYPE_JP2"; break;
        case 11 : 	$type = "IMAGETYPE_JPX"; break;
        case 12 : 	$type = "IMAGETYPE_JB2"; break;
        case 13 : 	$type = "IMAGETYPE_SWC"; break;
        case 14 : 	$type = "IMAGETYPE_IFF"; break;
        case 15 : 	$type = "IMAGETYPE_WBMP"; break;
        case 16 : 	$type = "IMAGETYPE_XBM"; break;
        case 17 : 	$type = "IMAGETYPE_ICO"; break;
        case 18 : 	$type = "IMAGETYPE_WEBP"; break;
        default :   $type = 'unknown'; break;
    }
    
    return $type;
    
}

function validateDate($date, $format = 'Y-m-d H:i:s')
{
    $d = DateTime::createFromFormat($format, $date);
    return $d && $d->format($format) == $date;
}

function dateInequality ($d1,$d2)
{
  
    $d1 = date('Ymd',strtotime($d1));
    $d2 = date('Ymd',strtotime($d2));    
    
    if ($d1 > $d2) {
        return 'G';
    }else{
        return 'L';
    }

}

function getRatio($num1, $num2){
    for($i = $num2; $i > 1; $i--) {
        if(($num1 % $i) == 0 && ($num2 % $i) == 0) {
            $num1 = $num1 / $i;
            $num2 = $num2 / $i;
        }
    }
    return "$num1:$num2";
}

function displayImg ($imageFile) {
    list($width, $height, $type, $attr) = getimagesize($imageFile);

    if ($height > $width) {
        $orientation = "Portrait";
        $newWidth = 300;
    } else if ($width > $height) {
        $orientation = "Landscape";
        $newWidth = 450;
    } else if ($width == $height) {
        $orientation = "Square";
        $newWidth = 450;        
    }

    $ar = $width/$height;
    $newHeight = floor($newWidth * ($height/$width));
    $attr = "width=\"$newWidth\" height=\"$newHeight\"";

    return array($attr,$ar,$orientation);
}

function queryWall($sql) {
    global $link;
    $result = mysqli_query($link, $sql);

    if (!$result) {
        echo "Error: " . mysqli_error($link) . "<br/>";
        die("It's dead!");
    } 
    else {
        return $result;
    } 
}

function rndClrSet () {
    
$clrSet = array
(
"#e6194B,#ffffff", 
"#3cb44b,#ffffff",
"#ffe119,#000000",
"#4363d8,#ffffff",
"#f58231,#ffffff",
"#911eb4,#ffffff",
"#42d4f4,#000000",
"#f032e6,#ffffff",
"#bfef45,#000000",
"#fabebe,#000000",
"#469990,#ffffff",
"#e6beff,#000000",
"#9A6324,#ffffff",
"#fffac8,#000000",
"#800000,#ffffff",
"#aaffc3,#000000",
"#808000,#ffffff",
"#ffd8b1,#000000",
"#000075,#ffffff",
"#a9a9a9,#ffffff",
"#ffffff,#000000",
"#000000,#ffffff"
);
$rndSet = mt_rand(0,21);
return $clrSet[$rndSet];
    
}
