<?php

/*
if (!function_exists('array_key_first')) 
{
   function array_key_first(array $arr) 
   {
       foreach($arr as $key => $unused) 
       {
           return $key;
       }
       return NULL;
   }
}

if (! function_exists("array_key_last")) 
{
    function array_key_last($array) 
    {
        if (!is_array($array) || empty($array)) 
        {
            return NULL;
        }
        return array_keys($array)[count($array)-1];
    }
}

    $curlogday = date('Ymd');
   $logdir = __DIR__ . '/logs1/';
   $curlog = $curlogday . '-reddit_walls.txt';
   $logsToKeep = 90;
    
   $scannedLogs = array_values(array_diff(scandir($logdir), array('..', '.')));
   $countLogs = count($scannedLogs);

   echo "# of logs = $countLogs<br/>\n";
   echo "<pre $preStyle>\n"; print_r($scannedLogs); echo "</pre>\n";
   
   $first = array_key_first($scannedLogs);
   $last  = array_key_last($scannedLogs);
   
   echo  $first . " ... " . $scannedLogs[$first] . "<br/>\n";
   echo  $last  . " ... " . $scannedLogs[$last]  . "<br/>\n";

   preg_match('/[0-9]{8}/', $scannedLogs[$first] , $fdate);
   preg_match('/[0-9]{8}/', $scannedLogs[$last] , $ldate);   

   $bdate = strtotime($fdate[0]);
   $edate = strtotime($ldate[0]);
   $datediff = $edate - $bdate;
   $noLogDays =  round($datediff / (60 * 60 * 24));

   echo "There are (or should be) $noLogDays days of logs<br/>\n";

*/

$rustart = getrusage();

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
ini_set('max_execution_time', 7200); //300 seconds = 5 minutes

ob_end_flush();
ob_start();

include_once('html-top.php');

include ('./includes/flush_n_sleep.inc.php');

function rutime($ru, $rus, $index) 
{
    return ($ru["ru_$index.tv_sec"]*1000 + intval($ru["ru_$index.tv_usec"]/1000))
     -  ($rus["ru_$index.tv_sec"]*1000 + intval($rus["ru_$index.tv_usec"]/1000));
}

function get_aspect_ratio($width, $height) 
{

    $gcd = function($width, $height) use (&$gcd) {
         return ($width % $height) ? $gcd($height, $width % $height) : $height;
     };
     $g = $gcd($width, $height);
     return $width/$g . ':' . $height/$g;
}

function getTitleFromLog ($searchfor)
{
    // escape special characters in the query
    $pattern = preg_quote($searchfor, '/');
    // finalise the regular expression, matching the whole line
    $pattern = "/^.*$pattern.*\$/m";
    // search, and store all matching occurences in $matches
    global $contents;
    if(preg_match_all($pattern, $contents, $matches)){
    // echo "Found matches:\n";
    // echo implode("\n", $matches[0]);
    $results = explode('=:=',implode("\n",$matches[0] ));
    return $results[1];
    }
    else{
    // echo "No matches found";
    return "NO TITLE FOUND";
    }
}

// OP7P - 1400 x 3120 pixels, 516 ppi, 19.5:9 aspect ratio.
// LG GPAD 5 - 1200 x 1920 pixels, 16:10 ratio (~224 ppi density)
// Alcatel A30 - 1200 x 800 pixels, 180 PPI
// Samsung Galaxy S8+ - 1440 x 2960 pixels, 18.5:9 ratio (~529 ppi density)

$docroot = $_SERVER['DOCUMENT_ROOT'] . '/';
$currlog = $docroot . 'webhooks/' . date('Ymd') . '-reddit_walls.txt';
$oldlogs = $docroot . 'webhooks/logs/';
$assets  = $docroot . 'webhooks/assets/';
$wallCategory = array('amoledbackgrounds','mobilewallpaper','wallpaper','wqhd_wallpaper','cityporn','earthporn','skyporn','spaceporn','waterporn','weatherporn');
$catPathColor = array(
    'amoledbackgrounds'=>array('wallpath'=>'/assets/amoledbackgrounds','colorkey'=>'#9C27B0'),  // purple 500
    'wallpaper'=>array('wallpath'=>'/assets/wallpaper','colorkey'=>'#FF5722'),                  // deep orange 500
    'wallpapers'=>array('wallpath'=>'/assets/wallpaper','colorkey'=>'#FF5722'),                 // deep orange 500
    'mobilewallpaper'=>array('wallpath'=>'/assets/mobilewallpaper','colorkey'=>'#CDDC39'),      // lime 500
    'mobilewallpapers'=>array('wallpath'=>'/assets/mobilewallpaper','colorkey'=>'#CDDC39'),     // lime 500
    'cityporn'=>array('wallpath'=>'/assets/cityporn','colorkey'=>'#2196F3'),                    // blue 500
    'earthporn'=>array('wallpath'=>'/assets/earthporn','colorkey'=>'#4CAF50'),                  // green 500
    'skyporn'=>array('wallpath'=>'/assets/skyporn','colorkey'=>'#F44336'),                      // red 500
    'spaceporn'=>array('wallpath'=>'/assets/spaceporn','colorkey'=>'#FFC107'),                  // amber 500
    'waterporn'=>array('wallpath'=>'/assets/waterporn','colorkey'=>'#009688'),                  // teal 500
    'weatherporn'=>array('wallpath'=>'/assets/weatherporn','colorkey'=>'#3F51B5'),              // indigo 500
    'tapet'=>array('wallpath'=>'/assets/tapet','colorkey'=>'#FFEB3B'),                          // yellow 500
    'wqhd_wallpaper'=>array('wallpath'=>'/assets/wqhd_wallpaper','colorkey'=>'#673AB7')         // deep purple 500
    );

// GET THE CONTENTS OF ALL THE LOGS TO SEARCH THROUGH
$scanOldLogs = array_values(array_diff(scandir($oldlogs), array('..', '.')));
sort($scanOldLogs,SORT_NATURAL);

$numOfOldLogs = count($scanOldLogs);

foreach ($scanOldLogs as $key=>$logfile)
{
    if (!isset($contents))
    {
        $contents = file_get_contents($oldlogs . $logfile);    
    }
    else
    {
        $contents .= file_get_contents($oldlogs . $logfile);
    }             
}

$contents .= file_get_contents($currlog);

foreach ($wallCategory as $wallCatKey=>$wallsubcat)
{
    $scannedAssets = array_values(array_diff(scandir($assets . $wallsubcat), array('..', '.')));
    $countScannedAssets = count($scannedAssets);

    // echo "<pre>"; print_r($catPathColor[$wallsubcat]); echo "</pre>";
    
    $cellBorderColor = "style='border:2px solid " . $catPathColor[$wallsubcat]['colorkey'] . ";'";

    echo "<div id='table-wrapper'>\n";
    echo "<table style=\"border: 10px {$catPathColor[$wallsubcat]['colorkey']};border-style: outset;\">\n";
    echo "\t<thead>\n";
    echo "\t\t<tr style='background-color:{$catPathColor[$wallsubcat]['colorkey']}'>\n";
    echo "\t\t\t<th colspan=8><b>" . strtoupper($wallsubcat) . "</b></th>\n";    
    echo "\t\t</tr>\n";
    echo "\t\t<tr>\n";
    echo "\t\t\t<th>No.</th>\n";
    echo "\t\t\t<th>Orig Title</th>\n";
    echo "\t\t\t<th>Image Filename</th>\n";
    echo "\t\t\t<th>Aspect</th>\n";
    echo "\t\t\t<th>Ratio</th>\n";
    echo "\t\t\t<th>Width</th>\n";
    echo "\t\t\t<th>Height</th>\n";
    echo "\t\t\t<th>Orientation</th>\n";
    echo "\t\t</tr>\n";
    echo "\t</thead>\n";
    echo "\t<tbody>\n";

    foreach ($scannedAssets as $assetKey=>$imgfile)
    {
        if (@getimagesize($assets . $wallsubcat . '/' . $imgfile) === false) 
        {
            echo "Bad image file " . $imgfile . "<br/>";
            unlink($assets . $wallsubcat . '/' . $imgfile);
            continue;
        }
        else 
        {
            list($originalWidth, $originalHeight) = getimagesize($assets . $wallsubcat . '/' . $imgfile);
            $ratio = $originalWidth / $originalHeight;
            $aspect = get_aspect_ratio($originalWidth, $originalHeight);
        }

        switch ($wallsubcat) {
            case 'amoledbackgrounds'  :
            case 'mobilewallpaper'    :
                if ($originalHeight > $originalWidth) {
                    $imgOrientation = 'Protrait';
                } elseif ($originalHeight < $originalWidth) {
                    $imgOrientation = 'Landscape';
                } elseif ($originalHeight == $originalWidth) {
                    $imgOrientation = 'Square';
                }
            break;
            case 'cityporn'         :
            case 'earthporn'        :
            case 'skyporn'          :
            case 'spaceporn'        :
            case 'wallpaper'        :
            case 'waterporn'        :
            case 'weatherporn'      :
            case 'wqhd_wallpaper'   :
                if ($originalHeight > $originalWidth) {
                    $imgOrientation = 'Protrait';
                } elseif ($originalHeight < $originalWidth) {
                    $imgOrientation = 'Landscape';
                } elseif ($originalHeight == $originalWidth) {
                    $imgOrientation = 'Square';
                }
        }        

        $wallTitle = getTitleFromLog($imgfile);

        echo "\t\t<tr >\n";
        echo "\t\t\t<td $cellBorderColor>" . sprintf("%04d/%04d",$assetKey,$countScannedAssets) . "</td>\n";
        echo "\t\t\t<td $cellBorderColor>$wallTitle</td>\n";
        echo "\t\t\t<td $cellBorderColor>$imgfile</td>\n";
        echo "\t\t\t<td $cellBorderColor>$aspect</td>\n";
        echo "\t\t\t<td $cellBorderColor>$ratio</td>\n";
        echo "\t\t\t<td $cellBorderColor>$originalWidth</td>\n";
        echo "\t\t\t<td $cellBorderColor>$originalHeight</td>\n";
        echo "\t\t\t<td $cellBorderColor>$imgOrientation</td>\n";
        echo "\t\t</tr>\n";
        
    }

    echo "\t</tbody>\n";
    echo "</table>\n";
    echo "</div>\n";

    flush_n_sleep(0);

}

$ru = getrusage();
echo "This process used " . rutime($ru, $rustart, "utime") .
    " ms for its computations\n";
echo "It spent " . rutime($ru, $rustart, "stime") .
    " ms in system calls\n";

include_once('html-btm.php');

?>