<?php

// http://handler-apis.project.zone/webhooks

// INSET LOG NAME AND LOG ITEMS INTO DATABASE
// WALLPAPER PROCESSING WILL GET THE TITLE OF THE WALLPAPER FROM
// INFORMATION IN THE DATABASE.

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
ini_set("date.timezone", "America/Indiana/Indianapolis");
ini_set('max_execution_time', 7200); //300 seconds = 5 minutes

include 'includes\db_connect-walllogs_local.php';
include 'includes\flush_n_sleep.inc.php';

$docroot = $_SERVER['DOCUMENT_ROOT'];

if (php_uname('s') == "Linux") {
    // for linux
    $s = $docroot . '/webhooks/assets';
    $d = '/var/www/sites/wallpapers/new';
    $k = '/var/www/krumo-0.6.0/class.krumo.php';
    $h = '/var/www/sites/wallpapers/hold';
} else {
    // for windows
    $s = $docroot . '/webhooks/assets';
    $d = 'D:/htdocs/sites/wallpapers/new';
    $k = 'D:/htdocs/krumo-0.6.0/class.krumo.php';
    $h = 'F:/hold';
}

// GET THE CONTENTS OF ALL THE LOGS TO SEARCH THROUGH
$oldlogs = $docroot . '/webhooks/logs/';
$processedlogs = $docroot . '/webhooks/old_logs/';
$scanOldLogs = array_values(array_diff(scandir($oldlogs), array('..', '.')));
sort($scanOldLogs, SORT_NATURAL);

$numOfOldLogs = count($scanOldLogs);

include_once 'includes/htmldoc-top-with-css.php';

// MAIN LOOP FOR LOGS TO PROCESS
foreach ($scanOldLogs as $key => $logfile)
{
  preg_match('/[0-9]{8}/', $logfile, $match);
  $logdateKey = strtotime($match[0]);
  $logVals = "$logdateKey,'$logfile'";

// CHECK AND INSERT LOG NAMES INTO DATABASE
    $query = "SELECT * FROM log_names WHERE log_key = '$logdateKey'";
    if ($result = mysqli_query($link1, $query)) {
        if (mysqli_num_rows($result) > 0) {
            echo <<<HTML
            <section style="background:#FFE0B2;padding:10px;padding:10px;border-top:2px solid #000000;border-bottom:2px solid #000000;">
              <p><b>Log $logfile already exists in database ... CONTINUING</b></p>
            </section>
            HTML;
        } else {
            if (!mysqli_query($link1, "INSERT INTO `log_names`(`log_key`, `log_name`) VALUES ($logVals)")) {
                echo <<<HTML
                <section style="background:#FFCDD2;color:#F44336;padding:10px;">
                  <p><b>Error: {mysqli_error($link1)}</b></p>
                </section>
              HTML;
                die("#1 It's dead!");
            } else {
                echo <<<HTML
                <section style="background:#C8E6C9;color:#4CAF50;padding:10px;padding:10px;border-top:2px solid #000000;border-bottom:2px solid #000000;">
                  <p><b>Log $logfile ($logdateKey) inserted into wall_logs.log_names</b></p>
                </section>
              HTML;
            }
        }
        flush_n_sleep(0);
    } else {
        echo <<<HTML
      <section style="background:##FFCDD2;color:##F44336;padding:10px;">
        <p><b>Error: {mysqli_error($link1)}</b></p>
      </section>
      HTML;
    }
// END CHECK AND INSERT LOG NAMES INTO DATABASE

// START PROCESSING LOG FILE CONTENTS
  $lines = file($oldlogs . $logfile);
  $howmanylines = count($lines);

  echo <<<HTML
    <section style="background:#C8E6C9;color:#4CAF50;padding:5px;border-top:2px solid #000000;border-bottom:2px solid #000000;">
      <p><b>Log $logfile ($logdateKey) has $howmanylines records to be processed.</b></p>
    </section>
  HTML;

  flush_n_sleep(0);

  foreach ($lines as $key => $line)
  {
    if (($line != "\n") && ($line != "\r"))
    {
        $lineParts = explode('=:=', $line);
        $logCat = strtolower($lineParts[0]);
        $logTitle = utf8_decode($lineParts[1]);
        $logImgUrl = $lineParts[2];
        $logTimeStamp = $lineParts[3];
        $logRedditTime = $lineParts[4];
        $logMyFileName = $lineParts[5];
        $logHttpCode = trim($lineParts[6]);
        if (empty($logHttpCode))
        {
            $logHttpCode = 200;
        }

        $runTimeStamp = date('Y-m-d H:i:s', strtotime($logTimeStamp));
        $redditPostStamp = date('Y-m-d H:i:s', strtotime(str_replace('at', '', $logRedditTime)));
        $logTitle = mysqli_real_escape_string($link1, $logTitle);
        $logImgUrl = mysqli_real_escape_string($link1, $logImgUrl);
        $logLineVals = "$logdateKey,'$logCat','$logTitle','$logImgUrl','$runTimeStamp','$redditPostStamp','$logMyFileName',$logHttpCode";
        $query = "SELECT * FROM log_items WHERE log_inhouse_name = '$logMyFileName'";

        if ($result = mysqli_query($link1, $query))
        {
          if (mysqli_num_rows($result) > 0)
          {
            $thisline=$key+1;
            echo <<<HTML
            <section style="background:#FFE0B2;color:#FF9800;padding:10px;border-top:2px solid #000000;border-bottom:2px solid #000000;">\n
              <p><b>Line $thisline of $logfile already exists in database</b> ... CONTINUING</p>\n
            </section>\n
            HTML;
          }
          else
          {
            $sql = "INSERT INTO `log_items`(`log_key`, `log_category`, `log_title`, `log_img_url`, `log_run_tstamp`, `log_reddit_post_dt`, `log_inhouse_name`, `log_http_code`) VALUES ($logLineVals)";
            if (!mysqli_query($link1, $sql))
            {
              $sqlErr = mysqli_error($link1);
              $sqlErrNo = mysqli_errno($link1);
              echo <<<HTML
              <section style="background:#FFCDD2;color:#F44336;padding:10px;border-top:2px solid #000000;border-bottom:2px solid #000000;">
                <p>Error : $sqlErr<br/>\n
                Error# : $sqlErrNo<br/>\n
                Log : $logfile<br/>\n
                Line : $key<br/>\n
                Category : $logCat<br/>\n
                Title : $logTitle<br/>\n
                URL : $logImgUrl<br/>\n
                TimeStamp : $logTimeStamp<br/>\n
                RedditTime : $logRedditTime<br/>\n
                Filename : $logMyFileName<br/>\n
                HTTP Code : $logHttpCode</p>\n
              </section>
              HTML;
              die("Died instering logfile item into database");
            }
            else
            {
              switch (strtolower($logCat))
              {
                case "amoledbackgrounds":
                    $bkgrd = "#E1BEE7";
                    $color = "#9C27B0";
                    break;
                case "cityporn":
                    $bkgrd = "#BBDEFB";
                    $color = "#2196F3";
                    break;
                case "earthporn":
                    $bkgrd = "#C8E6C9";
                    $color = "#4CAF50";
                    break;
                case "mobilewallpaper":
                    $bkgrd = "#F0F4C3";
                    $color = "#CDDC39";
                    break;
                case "skyporn":
                    $bkgrd = "#FFCDD2";
                    $color = "#F44336";
                    break;
                case "spaceporn":
                    $bkgrd = "#FFECB3";
                    $color = "#FFC107";
                    break;
                case "wallpaper":
                    $bkgrd = "#FFCCBC";
                    $color = "#FF5722";
                    break;
                case "waterporn":
                    $bkgrd = "#B2DFDB";
                    $color = "#009688";
                    break;
                case "weatherporn":
                    $bkgrd = "#C5CAE9";
                    $color = "#3F51B5";
                    break;
                case "wqhd_wallpaper":
                    $bkgrd = "#D1C4E9";
                    $color = "#673AB7";
                    break;
                default:
                    die("Unknown wallpaper category!!");
              }
              $thisline=$key+1;
              echo <<<HTML
                <section style="background:$bkgrd;color:$color;padding:10px;border-top:2px solid #000000;border-bottom:2px solid #000000;">\n
                  Line $thisline of $howmanylines from $logfile inserted into wall_logs.wall_items<br/>\n
                  Category : $logCat<br/>\n
                  Title : $logTitle<br/>\n
                  URL : $logImgUrl<br/>\n
                  TimeStamp : $logTimeStamp<br/>\n
                  RedditTime : $logRedditTime<br/>\n
                  Filename : $logMyFileName<br/>\n
                  HTTP Code : $logHttpCode<br/>\n
                </section>\n
              HTML;
              $src = $s . '/' . $logCat . '/' . $logMyFileName;
              $dst = $d . '/' . $logMyFileName;

              if (file_exists($src))
              {
                  if (copy($src, $dst))
                  {
                    echo <<<HTML
                      <section style="background:#424242;color:#F5F5F5;padding:5px;border-top:2px solid #000000;border-bottom:2px solid #000000;">
                        <p><b>GOOD COPY OF $src to $dst</b></p>\n
                        <p><b>$src has been DELETED</b></p>\n
                      </section>
                    HTML;
                    unlink($src);
                  }
                  else
                  {
                    echo <<<HTML
                      <section style="background:#F44336;color:#000000;padding:5px;border-top:2px solid #000000;border-bottom:2px solid #000000;">
                        <p><b>$src NOT COPIED - FIND OUT WHY!</b></p>
                      </section>
                    HTML;
                  }
              }
              elseif (file_exists($dst))
              {
                echo <<<HTML
                  <section style="background:#FFE0B2;color:#FF9800;padding:5px;border-top:2px solid #000000;border-bottom:2px solid #000000;">\n
                    <p><b>$logMyFileName had been moved to destination directory already</b></p>\n
                  </section>\n
                HTML;
              }
            }
              flush_n_sleep(0);
          }
        }
        else
        {
          $sqlErr = mysqli_error($link1);
          $sqlErrNo = mysqli_errno($link1);
          echo <<<HTML
            <section style="background:#FFCDD2;color:#F44336;padding:5px;border-top:2px solid #000000;border-bottom:2px solid #000000;">\n
              <p><b>Error : $sqlErr<br/>\nError# : $sqlErrNo</b></p>\n
            </section>\n
          HTML;
          die("Died instering logfile into database");
        }
    }
  }

  flush_n_sleep(0);

  // MOVE LOGS TO OLDLOGS
  if (rename($oldlogs . '/' . $logfile, $processedlogs . '/' . $logfile))
  {
    echo <<<HTML
      <section style="background:#424242;color:#F5F5F5;padding:5px;border-top:2px solid #000000;border-bottom:2px solid #000000;">\n
        <p><b>Done processing $logfile</b></p>\n
        <p>$oldlogs/$logfile changed to $processedlogs/$logfile</p>\n
      </section>\n
    HTML;
    echo "<br/>\n";
  }
  // END MOVE LOGS TO OLDLOGS

} 
// END MAIN LOOP FOR LOGS TO PROCESS

echo <<<HTML
    </div>
  </body>
</html>
HTML;
