<?php
$rustart = getrusage();

function rutime($ru, $rus, $index) 
{
    return ($ru["ru_$index.tv_sec"]*1000 + intval($ru["ru_$index.tv_usec"]/1000))
     -  ($rus["ru_$index.tv_sec"]*1000 + intval($rus["ru_$index.tv_usec"]/1000));
}

function get_aspect_ratio($width, $height) 
{

    $gcd = function($width, $height) use (&$gcd) {
         return ($width % $height) ? $gcd($height, $width % $height) : $height;
     };
     $g = $gcd($width, $height);
     return $width/$g . ':' . $height/$g;
}

function checkAspectRatio ($w,$h)
{
    $gcd = gmp_gcd($w,$h);
    $md = gmp_strval($gcd);
    $nw = $w/$md;
    $nh = $h/$md;
    return array($nw,$nh);    
} 

function getTitleFromLog ($searchfor)
{
    // escape special characters in the query
    $pattern = preg_quote($searchfor, '/');
    // finalise the regular expression, matching the whole line
    $pattern = "/^.*$pattern.*\$/m";
    // search, and store all matching occurences in $matches
    global $contents;
    if(preg_match_all($pattern, $contents, $matches)){
    // echo "Found matches:\n";
    // echo implode("\n", $matches[0]);
    $results = explode('=:=',implode("\n",$matches[0] ));
    return $results[1];
    }
    else{
    // echo "No matches found";
    return "NO TITLE FOUND";
    }
}

function numberTowords($num)
{ 
    $ones = array( 
    1 => "one", 
    2 => "two", 
    3 => "three", 
    4 => "four", 
    5 => "five", 
    6 => "six", 
    7 => "seven", 
    8 => "eight", 
    9 => "nine", 
    10 => "ten", 
    11 => "eleven", 
    12 => "twelve", 
    13 => "thirteen", 
    14 => "fourteen", 
    15 => "fifteen", 
    16 => "sixteen", 
    17 => "seventeen", 
    18 => "eighteen", 
    19 => "nineteen" 
    ); 
    $tens = array( 
    1 => "ten",
    2 => "twenty", 
    3 => "thirty", 
    4 => "forty", 
    5 => "fifty", 
    6 => "sixty", 
    7 => "seventy", 
    8 => "eighty", 
    9 => "ninety" 
    ); 
    $hundreds = array( 
    "hundred", 
    "thousand", 
    "million", 
    "billion", 
    "trillion", 
    "quadrillion" 
    ); //limit t quadrillion 
    $num = number_format($num,2,".",","); 
    $num_arr = explode(".",$num); 
    $wholenum = $num_arr[0]; 
    $decnum = $num_arr[1]; 
    $whole_arr = array_reverse(explode(",",$wholenum)); 
    krsort($whole_arr); 
    $rettxt = ""; 
    foreach($whole_arr as $key => $i){ 
    if($i < 20){ 
    $rettxt .= $ones[$i]; 
    }elseif($i < 100){ 
    $rettxt .= $tens[substr($i,0,1)]; 
    $rettxt .= " ".$ones[substr($i,1,1)]; 
    }else{ 
    $rettxt .= $ones[substr($i,0,1)]." ".$hundreds[0]; 
    $rettxt .= " ".$tens[substr($i,1,1)]; 
    $rettxt .= " ".$ones[substr($i,2,1)]; 
    } 
    if($key > 0){ 
    $rettxt .= " ".$hundreds[$key]." "; 
    } 
    } 
    if($decnum > 0){ 
    $rettxt .= " and "; 
    if($decnum < 20){ 
    $rettxt .= $ones[$decnum]; 
    }elseif($decnum < 100){ 
    $rettxt .= $tens[substr($decnum,0,1)]; 
    $rettxt .= " ".$ones[substr($decnum,1,1)]; 
    } 
    } 
    return $rettxt; 
    } 

    extract($_POST);
    if(isset($convert))
    {
    echo "<p align='center' style='color:blue'>".numberTowords("$num")."</p>";
}

$docroot = $_SERVER['DOCUMENT_ROOT'];
define('CURLOG', $docroot . '/webhooks/' . date('Ymd') . '-reddit_walls.txt');
define('OLDLOG', $docroot . '/webhooks/logs/');
$dir = $docroot . '/webhooks/assets';

echo "docroot = $docroot<br/>";
echo "current log file = " . CURLOG . "<br/>";
echo "old log file directory - " . OLDLOG . "<br/>";
echo "assest directory = $dir<br/>";
echo "<br/>"; 


$keyCount = 0;
$contents = null;
// $wallsubcat = 'wallpaper';

// GET THE CONTENTS OF ALL THE LOGS TO SEARCH THROUGH
$scanOldLogs = array_values(array_diff(scandir(OLDLOG), array('..', '.')));
sort($scanOldLogs,SORT_NATURAL);
echo "<pre>";
print_r($scanOldLogs);
echo "</pre>";

$numOfOldLogs = count($scanOldLogs);
echo "number of old logs = $numOfOldLogs<br/>";

echo "<pre>"; print_r($scanOldLogs); echo "</pre>";
die('OUCH!');

for ($x=$numOfOldLogs;$x>0;$x--) {
$contents .= file_get_contents(OLDLOG . 'reddit_walls(' . $x . ').txt');
}

$contents .= file_get_contents(CURLOG);
// echo "combined log =<br/>$contents<br/>";

echo "Combined " . numberTowords($numOfOldLogs) . " old logs along with the current log to find wallpaper titles<br/>\n";

    foreach (array('amoledbackgrounds','mobilewallpaper','wallpaper','wqhd_wallpaper','cityporn','earthporn','skyporn','spaceporn','waterporn','weatherporn'
    ) as $wallsubcat)
    {

    echo "wallsubcat = $wallsubcat<br/>";
    echo "dir to scan = " . $dir . '/' . $wallsubcat . "<br/>";

    // $scandir = array_values(array_diff(scandir($dir . '/' . $wallsubcat), array('..', '.')));
    // echo "<pre>";
    // print_r($scandir);
    // echo "</pre>";



    foreach (array_diff(scandir($dir), array('..', '.')) as $key1=>$level1) {
        echo "is dir check = " . $dir . '/' . $level1 . "<br/>";
        if (is_dir($dir . '/' . $level1)) {
            echo $dir . '/' . $level1 . " >> is a directory<br/>";
            $dirCount = count(array_diff(scandir($dir . '/' . $level1), array('..', '.')));
            if ($dirCount == 0) {
                $displayNoFiles = "no files in it";
            } elseif ($dirCount == 1) {
                $displayNoFiles = "$dirCount file in it";
            } else {
                $displayNoFiles = "$dirCount files in it";
            }

            if ($level1 == $wallsubcat) {

                echo "<h2>$level1 is a directory it has " . $displayNoFiles . "</h2><br/>\n";

                foreach (array_values(array_diff(scandir($dir . '/' . $level1), array('..', '.'))) as $key2=>$level2) { 
                    if (!is_dir($dir . '/' . $level1 . '/' . $level2)) {
                        $imageFile = $dir . '/' . $level1 . '/' . $level2;
                        echo "imageFile = $imageFile<br/>";
                        list($originalWidth, $originalHeight) = getimagesize($imageFile);
                        $ratio = $originalWidth / $originalHeight;
                        echo "ratio = $ratio = $originalWidth / $originalHeight<br/>";
                        $aspect = get_aspect_ratio($originalWidth, $originalHeight);
                        echo "aspect = $aspect<br/>";
                        switch ($level1) {
                            case 'amoledbackgrounds'  :
                            case 'mobilewallpaper'    :
                                if ($originalHeight > $originalWidth) {
                                    $imgOrientation = 'p';
                                    $orientation = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = Portrait<br/>\n";
                                    // echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = Portrait<br/>\n";
                                } elseif ($originalHeight < $originalWidth) {
                                    $imgOrientation = 'l';
                                    $orientation = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = <aspect style='color:red;'>Landscape</aspect><br/>\n";
                                    // echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = <aspect style='color:red;'>Landscape</aspect><br/>\n";
                                } elseif ($originalHeight == $originalWidth) {
                                    $imgOrientation = 's';
                                    $orientation = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = Square<br/>\n";
                                    // echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = Square<br/>\n";
                                }
                            break;
                            case 'cityporn'         :
                            case 'earthporn'        :
                            case 'skyporn'          :
                            case 'spaceporn'        :
                            case 'wallpaper'        :
                            case 'waterporn'        :
                            case 'weatherporn'      :
                            case 'wqhd_wallpaper'   :
                                if ($originalHeight > $originalWidth) {
                                    $imgOrientation = 'p';
                                    $orientation = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = <aspect style='color:red;'>Portrait</aspect><br/>\n";
                                    // echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = <aspect style='color:red;'>Portrait</aspect><br/>\n";
                                } elseif ($originalHeight < $originalWidth) {
                                    $imgOrientation = 'l';
                                    $orientation = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = Landscape<br/>\n";
                                    // echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = Landscape<br/>\n";
                                } elseif ($originalHeight == $originalWidth) {
                                    $imgOrientation = 's';
                                    $orientation = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = Square<br/>\n";
                                    // echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation = Square<br/>\n";
                                }
                        }

                        echo "imgOrientation = $imgOrientation<br/>";
                        echo "orientation = $orientation<br/>";

                        $chkAR = checkAspectRatio($originalWidth,$originalHeight);
                        $aspect1 = $chkAR[0] . ':' . $chkAR[1]; 

                        $mydata[$keyCount]['group'] = $level1;
                        $mydata[$keyCount]['width'] = $originalWidth;
                        $mydata[$keyCount]['height'] = $originalHeight;
                        $mydata[$keyCount]['dimension'] = $originalWidth . 'x' . $originalHeight;
                        $mydata[$keyCount]['ratio'] = $ratio;
                        $mydata[$keyCount]['aspect'] = $aspect;
                        $mydata[$keyCount]['orientation'] = strtoupper($imgOrientation);
                        $keyCount++;

                        $wallTitle = getTitleFromLog($level2);

                        echo $dir/$level1/$level2 . "<br/>";

                        // if ($imgOrientation == 'l') {
                            echo "<b>" . ($key2 + 1) . ")</b> <a href='$dir/$level1/$level2' target='_blank'>" . $level2 . "</a><br/>\n";
                            echo $orientation;
                            echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;group = $level1<br/>\n";
                            echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;title = $wallTitle<br/>\n";
                            echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;width = $originalWidth<br/>\n";
                            echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;height = $originalHeight<br/>\n";                                
                            echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ratio = $ratio<br/>\n";
                            echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;aspect = $aspect<br/>\n";
                            echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;check aspect = $aspect1<br/>\n";
                        // }        
                    }
                }
            }
        }
    }

    for ($x=0;$x<count($mydata);$x++) {
        if ($mydata[$x]['group'] == $wallsubcat) {
            $mygroup[$wallsubcat][] = strval($mydata[$x]['ratio']);
        }
    }

    echo "<pre>";
    $mygroup1 = array_count_values($mygroup[$wallsubcat]);
    ksort($mygroup1,SORT_NATURAL);
    print_r($mygroup1);
    echo "</pre>";

    foreach ($mygroup1 as $mygroup1Key=>$mygroup1Value)
    {
        echo $mygroup1Key . " => " . $mygroup1Value . "<br/>\n";    
        for ($x=0;$x<count($mydata);$x++) { 
            if ($mydata[$x]['group'] == $wallsubcat) {
                if (strval($mydata[$x]['ratio']) == $mygroup1Key) {
                    echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{$mydata[$x]['aspect']} >> w:{$mydata[$x]['width']} h:{$mydata[$x]['height']} ({$mydata[$x]['orientation']})<br/>\n";
                }
            }
        }
    }

    // unset($mydata);
    unset($mygroup);
    unset($mygroup1);
    unset($mygroup1Key);
    unset($mygroup1Value);
}

$ru = getrusage();
echo "This process used " . rutime($ru, $rustart, "utime") .
    " ms for its computations\n";
echo "It spent " . rutime($ru, $rustart, "stime") .
    " ms in system calls\n";

?>