<?php
$rustart = getrusage();
ini_set("date.timezone", "America/Indiana/Indianapolis");
parse_str($_SERVER['QUERY_STRING'], $ifttt);

function rutime($ru, $rus, $index) {
    return ($ru["ru_$index.tv_sec"]*1000 + intval($ru["ru_$index.tv_usec"]/1000))
     -  ($rus["ru_$index.tv_sec"]*1000 + intval($rus["ru_$index.tv_usec"]/1000));
}

function ob_file_callback($buffer){
  global $ob_file;
  fwrite($ob_file,$buffer);
}

function checkExt ($filename,$runStamp) {
    $allowed = array('gif', 'png', 'jpg');
    $ext = pathinfo($filename, PATHINFO_EXTENSION);
    if (!in_array($ext, $allowed)) {
        echo "INVALD FILE EXTENSION\n";
        echo "END   $runStamp ==============================================================\n";
        ob_end_flush();
        die();
    }
}

// Timestamp for our yyyymmdd-reddit_wall.txt log
$runStamp = date('Y/m/d G:i:s');

$ob_file = fopen('webhooks_log.txt','a+');
ob_start('ob_file_callback');

echo "BEGIN $runStamp ==============================================================\n";

// GET CURRENT DATE FROM FILE TO COMPARE WITH SYSTEM TO ADVANCE OR RESET 
$curDayHandle = fopen('currentday.txt','r');
$curday = trim(fgets($curDayHandle));
fclose($curDayHandle);

$sysday = date('Ymd');

$logdir = __DIR__ . '/logs';
$curlog = $curday . '-reddit_walls.txt';
$newlog = $sysday . '-reddit_walls.txt';
$logsToKeep = 500; 

echo "sysday = $sysday\n";
echo "logdir = $logdir\n";
echo "curlog = $curlog\n";
echo "newlog = $newlog\n";
echo "logsToKeep = $logsToKeep\n";

checkExt($ifttt['imageurl'],$runStamp);

if (empty($ifttt['imageurl'])) {
    echo "END   $runStamp ==============================================================\n";
    ob_end_flush();
    die();
}


if (strtotime($sysday) > strtotime($curday))
{

    echo "New day - New log\n";

    // Move previous days log to the logs directory
    if (!file_exists($logdir . '/' . $curlog))
    {
        rename(__DIR__ . '/' . $curlog,$logdir . '/' . $curlog);
        echo "rename " . __DIR__ . '/' . $curlog . " TO " . $logdir . "/" . $curlog . "\n";
    }
    else
    {
        echo "a problem exists and $logdir/$curlog already exists<br/>\n";
    }

    // Create a fresh log file
    if (!file_exists($newlog))
    {
        touch($newlog);
        echo "create new log = $newlog\n";
        $curlog = $newlog;
        echo "curlog = newlog\n";
    }
    else
    {
        echo "a problem exists and $newlog already exists<br/>\n";
    }

    $subcount = 1;
    echo "subcount reset to 1\n";
    $cntHandle = fopen('dlycounter.txt','w');
    echo "update dlycounter.txt for new day\n";
    fputs($cntHandle,$subcount);
    fclose($cntHandle); 
    
    $curDayHandle = fopen('currentday.txt','w');
    echo "update currentday.txt with the new date\n";
    fputs($curDayHandle,$sysday);
    fclose($curDayHandle);
  }

// OPEN COUNTER FILE AND GET CURRENT NUMBER;
$cntHandle = fopen('dlycounter.txt','r');
$subcount = fgets($cntHandle);
fclose($cntHandle);

$ifttt['postedatU'] = str_replace('at',' ',$ifttt['postedat']);

switch ($ifttt['sub']) {
  case 'wallpapers' : $ifttt['sub'] = "wallpaper";
                      break;
  case 'mobilewallpapers' :
  case 'MobileWallpaper' :  $ifttt['sub'] = "mobilewallpaper";
                      break;
}

$outputWall = str_replace('\\', '/', __DIR__) . '/assets/' . strtolower($ifttt['sub']) . '/' . strtotime($ifttt['postedatU']) . '-' . strtolower($ifttt['sub']) . '-' . sprintf('%04d', $subcount) . substr($ifttt['imageurl'], strrpos($ifttt['imageurl'],'.'));
echo "outputWall = $outputWall\n";
echo "ifttt(imageurl) = " . $ifttt['imageurl'] . "\n";

$ch = curl_init($ifttt['imageurl']);
$fp = fopen($outputWall, 'wb');
curl_setopt($ch, CURLOPT_FILE, $fp);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_exec($ch);

if (!curl_errno($ch)) {
  switch ($http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE)) {
    case 200:  # OK
        echo "It was good : $http_code\n";
        curl_close($ch);
        fclose($fp);
        $cntHandle = fopen('dlycounter.txt','w');          
        $subcount++;
        fputs($cntHandle,$subcount);
        fclose($cntHandle);
        break;
    default:
        echo "Unexpected HTTP code: $http_code\n";
        unlink($outputWall);
  }
}

// COMPILE LIST OF WALLPAPERS 
$stuff = $ifttt['sub'] . '=:=' . $ifttt['title'] . '=:=' . $ifttt['imageurl'] . '=:=' . $runStamp . '=:=' . $ifttt['postedat'] . '=:=' . substr($outputWall,strrpos($outputWall,'/')+1) . '=:=' . $http_code . "\n";
$handle = fopen($curlog, "a");
fwrite($handle, $stuff);
fclose($handle);

$ru = getrusage();

echo "This process used " . rutime($ru, $rustart, "utime") .
    " ms for its computations\n";
echo "It spent " . rutime($ru, $rustart, "stime") .
    " ms in system calls\n";

echo "END   $runStamp ==============================================================\n";

ob_end_flush();
?>
